#ifndef __DEBUG_H__
#define __DEBUG_H__

#endif

#ifndef __DISPLAY_COMMON_H__
#define __DISPLAY_COMMON_H__

#include <stdlib.h>
#include <stdint.h>
#include "control_comm.h"

#define  AIR_CONDITION      				1
#define  FLOOR_HEATING						2
#define	 FAN								3


//enum{
//	SYSTEM_MODE_OFF 				= 0,
//	SYSTEM_MODE_AUTO 				= 1,
//	SYSTEM_MODE_MANUAL 				= 2,
//	SYSTEM_MODE_COOLING 			= 3,
//	SYSTEM_MODE_HEATING 			= 4,
//	SYSTEM_MODE_EMERGENCY_HEATING 	= 5,
//	SYSTEM_MODE_PRE_COOLING			= 6,
//	SYSTEM_MODE_AIR					= 7,	
//	SYSTEM_MODE_DRY					= 8,
//	SYSTEM_MODE_SLEEP				= 9,
//	SYSTEM_MODE_ROLL				= 10,
//};
enum{
	ERROR_CODE_NONE 				= 0,
	ERROR_CODE_SENSOR_WRONG 		= 1,
	ERROR_CODE_ZIGBEE_WRONG 		= 2,
	ERROR_CODE_FILTER_WASH 			= 3,
	ERROR_CODE_COOL_DEFIND 			= 4,
	ERROR_CODE_AIR_CONDITION		= 5,
};
typedef struct
{
	u8    on_off;							//							
	u8    power_off_time;                   //ʱʱ  
    u8    power_off_flage;                  //ʱػͼ	
    s16   real_temperature;				    //¶ 
    u16   set_temperature;				    //¶ 
    s8    correct_temperature;              //¶У׼ֵ
    u8    system_type; 						//ϵͳ   
    u8    operation_mode;                   //ģʽ 
    u8    wind_speed;                       //   0  1  2  3 ߣ4 5Զ 6  7еͣ8 и 9    ĬԶ    
    u8    lock_flage;                       //ͯʾͼ 
	u8    air_cond_type;					//յ   1.̹  2߿
	u8    air_wind_direct;					//  0  1 2        1
	u8    error;							//error code
	u16   screen_save_time;					//ʱ       00  30
	u16   filter_wash_time;					//ϴʱ    3000
	u8    no_disturb_mode;					//ģʽ      0
	u8    air_product_id;
	u8    air_type;
}OLED_AIR_DSD;
typedef struct
{
	u8    on_off;							//			  1				
	u8    power_off_time;                   //ʱʱ  
    u8    power_off_flage;                  //ʱػͼ	
    s16   real_temperature;				    //¶ 
    u16   set_temperature;				    //¶        26
    s8    correct_temperature;              //¶У׼ֵ
    u8    system_type; 						//ϵͳ       ֶ
    u8    lock_flage;                       //ͯʾͼ 
	u8    floor_heating_type;				//ů   1.ˮů  2ů
	u8    error;							//error code
	u16   screen_save_time;					//ʱ
	u8    no_disturb_mode;					//ģʽ
}OLED_FLOOR_HEATING_DSD;
typedef struct
{
	u8    on_off;							//							
	u8    power_off_time;                   //ʱʱ  
    u8    power_off_flage;                  //ʱػͼ
	s16   real_temperature;				    //¶ 
	s8    correct_temperature;              //¶У׼ֵ	
    u8    system_type; 						//ϵͳ   
    u8    wind_speed;                       //    1  2  3 ߣ5Զ        Զ
    u8    lock_flage;                       //ͯʾͼ 
	u8    error;							//error code
	u16   screen_save_time;					//ʱ
	u16   filter_wash_time;					//ϴʱ
	u8    no_disturb_mode;					//ģʽ
}OLED_FAN_DSD;
typedef struct Display_Data
{     
	u8    		device_type;
    u8   		net_work_flage;                   //ZigBeeͨ״̬ͼ
	u8	  		screen_page;
    u8    		aging_test_flag;                  //ϻ־λ  0 0-15minǰϻ115min - 4Сʱϻ 2ʾϻ
	uint64_t    local_timer;					  //ǰʱ䣨ϵ翪ʼ㣩
	u8    		mcu_Version;                       //min58汾
	u8    		zigbee_Version;                    //zigbee汾
	u8          binding_device;					  //0 δ  1󶨿յ2ů3·
	u8          recv_lcd_off;					  //ܵϢָ
	u8			is_dispaly_cur_temp;
	u8			zigbee_mac[8];
	OLED_AIR_DSD  Air_Device;
	OLED_FLOOR_HEATING_DSD  FLOOR_Device;
	OLED_FAN_DSD  FAN_Device;
}OLED_ALL_DSD;

	
typedef struct 
{
    u8  adjust_fan_speed_status;     //·ٰ   key2
	u8  presss_status;     			//·ٰ   key2

}Key_Operation_Status;
typedef struct{
	u32  onDuration;
	u32  offDuration;
	u32  onCounter;
	u32  offCounter;
	u8   start;
	u8   end;
	u32  blink_cnt;
}NET_INDICATOR;

typedef struct{
	u8   enter_config_mode;
	u8   config_page;
	u8   config_page1_func_value;
	u8   config_page2_value;
	u8   support_function_len;
	u8   support_function_list[6];       //1,̹ܹ 2,¶У׼ 3,Ƿʾǰ¶,4, ʱʱ 10 ָ
	volatile u32  config_time_ms;
	volatile u8   config_time_s;
}Local_Config_Operation;
typedef enum  {
	LOCAL_FUNC_FAN_PANEL_SETTING 			= 1,
	LOCAL_FUNC_CALIBRATE_TEMPER  			= 2,
	LOCAL_FUNC_IS_DISPLAY_CURRENT_TEMPER  	= 3,
	LOCAL_FUNC_SCREEN_SAVING_TIME  			= 4,
	LOCAL_FUNC_NOT_DISTURB  				= 5,
	LOCAL_FUNC_FILTER_TIME  				= 10,
	LOCAL_FUNC_RESET_FACTORY  				= 100,
}Local_Config_Function;

#define   SysIndicatorScanTimer  20

extern  OLED_ALL_DSD  Oled_Display_Info; 
extern  BACKLIGHT_CONTROL sBacklight;
extern  Key_Operation_Status  gKey_Press_Info;
	

void Display_poweroff_time(u8 display_time);
extern void  display_error(u8 error_value);
void Operate_Led_Button(u8 device_type,u8 on_off);
void Set_CMD_Handler(u8 device_type,u16 opcode,u8 *arg,u8 arg_len);
void display_current_page(void);
u16 GetNetScanTime( void );
void SetNetScanTime(u16 uSetkeyScanTime);
u8  kNetIndicatorIsBlinking(void);
void kNetIndicatorOptTrigger(uint8_t id, uint32_t duration_on_ms, uint32_t duration_off_ms, uint32_t times, u8 start, u8 end );
void kLedModuleActionDetectCallback(void );

void  display_set_temp(u8 display_mode,int temp_value,u8 ararm_f);
void  display_system_mode(u8 heat,u8 dry,u8 cold ,u8 air,u8 sleep,u8 manufture,u8 Auto,u8 Roll);
void  display_wind_speed(u8 wind_speed,u8 support_type);
void  display_wind_direct(u8 low,u8 mediu,u8 high);
void Displayt_System_Mode(u8 system_mode);
void Oled_Display_whole(void);
void PowerOff(void);
void EnterScreenSaveMode(void);
void Detect_Human_Dispaly(void);
u8 System_Mode_Trans(u8 device_type,u8 is_support_sleep);
void Fan_Button_Handler(void);
void delay_confirm_fan_speed(void);								//ǰʱ,
void Control_LED_ON_OFF(u8 onoff_bits);
u8 Key_Operate_Config_Operation(u8 keyid,u8 keyEvent);
u8 IsLocalConfigMode(void);
u8  kAllLedIsBlinking(void);
void Display_Up_Contend(u8 device_type);
void Setup_Mode_Handle (void);

#define Operation_LED(X) 	 		Operate_Led_Button(Oled_Display_Info.screen_page,X)
#define  Reload_Save_Time()   		do{ sBacklight.blacklight_flag 		= 1;\
										sBacklight.time_blacklight_ms 	= 0;\
										sBacklight.time_blacklight_s 	= 0;\
										LCD_CONTROL(1);	\
										Operation_LED(1);}while(0);

										
										
										
#endif 
